using System;
using System.Data;
using System.Collections.Generic;
namespace RMYY_CallCenter_Api.Bll
{
    /// <summary>
    /// T_Sys_Department
    /// </summary>
    public partial class T_Sys_Department
    {
        private readonly Dal.T_Sys_Department dal = new Dal.T_Sys_Department();
        public T_Sys_Department()
        { }
        #region  BasicMethod
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(string F_DeptCode)
        {
            return dal.Exists(F_DeptCode);
        }

        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(Model.T_Sys_Department model)
        {
            return dal.Add(model);
        }

        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(Model.T_Sys_Department model)
        {
            return dal.Update(model);
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_DeptId)
        {

            return dal.Delete(F_DeptId);
        }
        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool DeleteList(string F_DeptIdlist)
        {
            return dal.DeleteList(F_DeptIdlist);
        }

        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public Model.T_Sys_Department GetModel(int F_DeptId)
        {

            return dal.GetModel(F_DeptId);
        }

        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public Model.T_Sys_Department GetModel(string F_DeptCode)
        {

            return dal.GetModel(F_DeptCode);
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            return dal.GetList(strWhere);
        }
        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            return dal.GetList(Top, strWhere, filedOrder);
        }
        /// <summary>
        /// 获得数据列表
        /// </summary>
        public List<Model.T_Sys_Department> GetModelList(string strWhere)
        {
            DataSet ds = dal.GetList(strWhere);
            return DataTableToList(ds.Tables[0]);
        }
        /// <summary>
        /// 获得数据列表
        /// </summary>
        public List<Model.T_Sys_Department> DataTableToList(DataTable dt)
        {
            List<Model.T_Sys_Department> modelList = new List<Model.T_Sys_Department>();
            int rowsCount = dt.Rows.Count;
            if (rowsCount > 0)
            {
                Model.T_Sys_Department model;
                for (int n = 0; n < rowsCount; n++)
                {
                    model = dal.DataRowToModel(dt.Rows[n]);
                    if (model != null)
                    {
                        modelList.Add(model);
                    }
                }
            }
            return modelList;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetAllList()
        {
            return GetList("");
        }

        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            return dal.GetRecordCount(strWhere);
        }

        #endregion  BasicMethod

        public int GetDeplayer(int deptid)
        {
            int layer = 1;
            var model = dal.GetModel(deptid);
            if (model != null)
            {
                if (model.F_ParentId != 0)
                {
                    layer++;
                    GetDeplayer(Convert.ToInt32(model.F_ParentId));
                }
            }
            return layer;
        }


        public int GetDeplayer1(int deptid)
        {
            int layer = 1;
            var model = dal.GetModel(deptid);
            if (model.F_ParentId == 0)
            {
                return layer;
            }
            else
            {
                layer++;
                return GetDeplayer(Convert.ToInt32(model.F_ParentId));
            }
        }

    }
}

